Index: trunk/source/Lib/TLibCommon/TComPic.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComPic.h	(revision 1357)
+++ trunk/source/Lib/TLibCommon/TComPic.h	(revision 1386)
@@ -154,5 +154,5 @@
   TComDecodedRps        m_decodedRps;
 #endif
-#if NH_3D
+#if NH_3D_VSO
   Int                   m_viewIndex;
   Bool                  m_isDepth;
@@ -189,4 +189,5 @@
 
   TComPicSym*   getPicSym()           { return  &m_picSym;    }
+  const TComPicSym* getPicSym() const { return  &m_picSym;    }
   TComSlice*    getSlice(Int i)       { return  m_picSym.getSlice(i);  }
   Int           getPOC() const        { return  m_picSym.getSlice(m_uiCurrSliceIdx)->getPOC();  }
@@ -247,11 +248,11 @@
 #if NH_MV
    Void          setLayerId            ( Int layerId )    { m_layerId      = layerId; }
-   Int           getLayerId            ()                 { return m_layerId;    }
+   Int           getLayerId            () const           { return m_layerId;    }
    
    Void          setViewId             ( Int viewId )     { m_viewId = viewId;   }
-   Int           getViewId             ()                 { return m_viewId;     }
+   Int           getViewId             () const           { return m_viewId;     }
 
    Void          setPicOutputFlag(Bool b)                 { m_bPicOutputFlag = b;      }
-   Bool          getPicOutputFlag()                       { return m_bPicOutputFlag ;  }
+   Bool          getPicOutputFlag() const                 { return m_bPicOutputFlag ;  }
 
    Bool          getPocResetPeriodId();
@@ -310,7 +311,7 @@
    Void          print( Int outputLevel );
 
-#if NH_3D
+#if NH_3D_VSO
    Void          setViewIndex          ( Int viewIndex )  { m_viewIndex = viewIndex;   }
-   Int           getViewIndex          ()                 { return m_viewIndex;     }
+   Int           getViewIndex          () const           { return m_viewIndex;     }
 
    Void          setIsDepth            ( Bool isDepth )   { m_isDepth = isDepth; }
@@ -403,5 +404,5 @@
   TComList<TComSubDpb*>       m_subDpbs; 
   Bool                        m_printPicOutput; 
-#if NH_3D                     
+#if NH_3D_VSO
   const TComVPS*              m_vps; 
 #endif
@@ -447,8 +448,8 @@
   Void                   print(); 
 
-#if NH_3D                                   
+#if NH_3D_VSO
   Void                   setVPS                        ( const TComVPS* vps ) { m_vps = vps;  }; 
-  TComPic*               getPic                        ( Int viewIndex, Bool depthFlag, Int poc );
-  TComPicYuv*            getPicYuv                     ( Int viewIndex, Bool depthFlag, Int poc, Bool recon );
+  TComPic*               getPic                        ( Int viewIndex, Bool depthFlag, Int auxId, Int poc );
+  TComPicYuv*            getPicYuv                     ( Int viewIndex, Bool depthFlag, Int auxId, Int poc, Bool recon );
 #endif  
 
Index: trunk/source/Lib/TLibCommon/TComPicSym.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPicSym.cpp	(revision 1357)
+++ trunk/source/Lib/TLibCommon/TComPicSym.cpp	(revision 1386)
@@ -140,12 +140,18 @@
   clearSliceBuffer();
 
+  if (m_pictureCtuArray)
+  {
   for (Int i = 0; i < m_numCtusInFrame; i++)
   {
+      if (m_pictureCtuArray[i])
+      {
     m_pictureCtuArray[i]->destroy();
     delete m_pictureCtuArray[i];
     m_pictureCtuArray[i] = NULL;
   }
+    }
   delete [] m_pictureCtuArray;
   m_pictureCtuArray = NULL;
+  }
 
   delete [] m_ctuTsToRsAddrMap;
Index: trunk/source/Lib/TLibCommon/TComPicYuv.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 1357)
+++ trunk/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 1386)
@@ -79,56 +79,76 @@
 
 
-Void TComPicYuv::create ( const Int iPicWidth,                ///< picture width
-                          const Int iPicHeight,               ///< picture height
+Void TComPicYuv::createWithoutCUInfo ( const Int picWidth,                 ///< picture width
+                                       const Int picHeight,                ///< picture height
+                                       const ChromaFormat chromaFormatIDC, ///< chroma format
+                                       const Bool bUseMargin,              ///< if true, then a margin of uiMaxCUWidth+16 and uiMaxCUHeight+16 is created around the image.
+                                       const UInt maxCUWidth,              ///< used for margin only
+                                       const UInt maxCUHeight)             ///< used for margin only
+
+{
+  m_picWidth          = picWidth;
+  m_picHeight         = picHeight;
+
+#if NH_3D_IV_MERGE
+  m_iCuWidth        = maxCUWidth;
+  m_iCuHeight       = maxCUHeight;
+
+  m_iNumCuInWidth   = picWidth / m_iCuWidth;
+  m_iNumCuInWidth  += ( picHeight % m_iCuWidth ) ? 1 : 0;
+  // Check if m_iBaseUnitWidth and m_iBaseUnitHeight need to be derived here
+#endif
+
+  m_chromaFormatIDC   = chromaFormatIDC;
+  m_marginX          = (bUseMargin?maxCUWidth:0) + 16;   // for 16-byte alignment
+  m_marginY          = (bUseMargin?maxCUHeight:0) + 16;  // margin for 8-tap filter and infinite padding
+  m_bIsBorderExtended = false;
+
+  // assign the picture arrays and set up the ptr to the top left of the original picture
+  for(UInt comp=0; comp<getNumberValidComponents(); comp++)
+  {
+    const ComponentID ch=ComponentID(comp);
+    m_apiPicBuf[comp] = (Pel*)xMalloc( Pel, getStride(ch) * getTotalHeight(ch));
+    m_piPicOrg[comp]  = m_apiPicBuf[comp] + (m_marginY >> getComponentScaleY(ch)) * getStride(ch) + (m_marginX >> getComponentScaleX(ch));
+  }
+  // initialize pointers for unused components to NULL
+  for(UInt comp=getNumberValidComponents();comp<MAX_NUM_COMPONENT; comp++)
+  {
+    m_apiPicBuf[comp] = NULL;
+    m_piPicOrg[comp]  = NULL;
+  }
+
+  for(Int chan=0; chan<MAX_NUM_CHANNEL_TYPE; chan++)
+    {
+    m_ctuOffsetInBuffer[chan]   = NULL;
+    m_subCuOffsetInBuffer[chan] = NULL;
+    }
+  }
+
+
+
+Void TComPicYuv::create ( const Int picWidth,                 ///< picture width
+                          const Int picHeight,                ///< picture height
                           const ChromaFormat chromaFormatIDC, ///< chroma format
-                          const UInt uiMaxCUWidth,            ///< used for generating offsets to CUs. Can use iPicWidth if no offsets are required
-                          const UInt uiMaxCUHeight,           ///< used for generating offsets to CUs. Can use iPicHeight if no offsets are required
-                          const UInt uiMaxCUDepth,            ///< used for generating offsets to CUs. Can use 0 if no offsets are required
+                          const UInt maxCUWidth,              ///< used for generating offsets to CUs.
+                          const UInt maxCUHeight,             ///< used for generating offsets to CUs.
+                          const UInt maxCUDepth,              ///< used for generating offsets to CUs.
                           const Bool bUseMargin)              ///< if true, then a margin of uiMaxCUWidth+16 and uiMaxCUHeight+16 is created around the image.
 
 {
-  m_iPicWidth         = iPicWidth;
-  m_iPicHeight        = iPicHeight;
+  createWithoutCUInfo(picWidth, picHeight, chromaFormatIDC, bUseMargin, maxCUWidth, maxCUHeight);
 
 #if NH_3D_IV_MERGE
-  m_iCuWidth        = uiMaxCUWidth;
-  m_iCuHeight       = uiMaxCUHeight;
-
-  m_iNumCuInWidth   = m_iPicWidth / m_iCuWidth;
-  m_iNumCuInWidth  += ( m_iPicWidth % m_iCuWidth ) ? 1 : 0;
-
-  m_iBaseUnitWidth  = uiMaxCUWidth  >> uiMaxCUDepth;
-  m_iBaseUnitHeight = uiMaxCUHeight >> uiMaxCUDepth;
-#endif
-
-  m_chromaFormatIDC   = chromaFormatIDC;
-  m_iMarginX          = (bUseMargin?uiMaxCUWidth:0) + 16;   // for 16-byte alignment
-  m_iMarginY          = (bUseMargin?uiMaxCUHeight:0) + 16;  // margin for 8-tap filter and infinite padding
-  m_bIsBorderExtended = false;
-
-  // assign the picture arrays and set up the ptr to the top left of the original picture
-  {
-    Int chan=0;
-    for(; chan<getNumberValidComponents(); chan++)
-    {
-      const ComponentID ch=ComponentID(chan);
-      m_apiPicBuf[chan] = (Pel*)xMalloc( Pel, getStride(ch)       * getTotalHeight(ch));
-      m_piPicOrg[chan]  = m_apiPicBuf[chan] + (m_iMarginY >> getComponentScaleY(ch))   * getStride(ch)       + (m_iMarginX >> getComponentScaleX(ch));
-    }
-    for(;chan<MAX_NUM_COMPONENT; chan++)
-    {
-      m_apiPicBuf[chan] = NULL;
-      m_piPicOrg[chan]  = NULL;
-    }
-  }
-
-
-  const Int numCuInWidth  = m_iPicWidth  / uiMaxCUWidth  + (m_iPicWidth  % uiMaxCUWidth  != 0);
-  const Int numCuInHeight = m_iPicHeight / uiMaxCUHeight + (m_iPicHeight % uiMaxCUHeight != 0);
-  for(Int chan=0; chan<2; chan++)
-  {
-    const ComponentID ch=ComponentID(chan);
-    const Int ctuHeight=uiMaxCUHeight>>getComponentScaleY(ch);
-    const Int ctuWidth=uiMaxCUWidth>>getComponentScaleX(ch);
+  m_iBaseUnitWidth  = maxCUWidth  >> maxCUDepth;
+  m_iBaseUnitHeight = maxCUHeight >> maxCUDepth;
+#endif
+
+
+  const Int numCuInWidth  = m_picWidth  / maxCUWidth  + (m_picWidth  % maxCUWidth  != 0);
+  const Int numCuInHeight = m_picHeight / maxCUHeight + (m_picHeight % maxCUHeight != 0);
+  for(Int chan=0; chan<MAX_NUM_CHANNEL_TYPE; chan++)
+  {
+    const ChannelType ch= ChannelType(chan);
+    const Int ctuHeight = maxCUHeight>>getChannelTypeScaleY(ch);
+    const Int ctuWidth  = maxCUWidth>>getChannelTypeScaleX(ch);
     const Int stride = getStride(ch);
 
@@ -143,9 +163,9 @@
     }
 
-    m_subCuOffsetInBuffer[chan] = new Int[(size_t)1 << (2 * uiMaxCUDepth)];
-
-    const Int numSubBlockPartitions=(1<<uiMaxCUDepth);
-    const Int minSubBlockHeight    =(ctuHeight >> uiMaxCUDepth);
-    const Int minSubBlockWidth     =(ctuWidth  >> uiMaxCUDepth);
+    m_subCuOffsetInBuffer[chan] = new Int[(size_t)1 << (2 * maxCUDepth)];
+
+    const Int numSubBlockPartitions=(1<<maxCUDepth);
+    const Int minSubBlockHeight    =(ctuHeight >> maxCUDepth);
+    const Int minSubBlockWidth     =(ctuWidth  >> maxCUDepth);
 
     for (Int buRow = 0; buRow < numSubBlockPartitions; buRow++)
@@ -153,9 +173,8 @@
       for (Int buCol = 0; buCol < numSubBlockPartitions; buCol++)
       {
-        m_subCuOffsetInBuffer[chan][(buRow << uiMaxCUDepth) + buCol] = stride  * buRow * minSubBlockHeight + buCol * minSubBlockWidth;
-      }
-    }
-  }
-  return;
+        m_subCuOffsetInBuffer[chan][(buRow << maxCUDepth) + buCol] = stride  * buRow * minSubBlockHeight + buCol * minSubBlockWidth;
+      }
+    }
+  }
 }
 
@@ -164,12 +183,12 @@
 Void TComPicYuv::destroy()
 {
-  for(Int chan=0; chan<MAX_NUM_COMPONENT; chan++)
-  {
-    m_piPicOrg[chan] = NULL;
-
-    if( m_apiPicBuf[chan] )
-    {
-      xFree( m_apiPicBuf[chan] );
-      m_apiPicBuf[chan] = NULL;
+  for(Int comp=0; comp<MAX_NUM_COMPONENT; comp++)
+  {
+    m_piPicOrg[comp] = NULL;
+
+    if( m_apiPicBuf[comp] )
+    {
+      xFree( m_apiPicBuf[comp] );
+      m_apiPicBuf[comp] = NULL;
     }
   }
@@ -194,14 +213,30 @@
 Void  TComPicYuv::copyToPic (TComPicYuv*  pcPicYuvDst) const
 {
-  assert( m_iPicWidth  == pcPicYuvDst->getWidth(COMPONENT_Y)  );
-  assert( m_iPicHeight == pcPicYuvDst->getHeight(COMPONENT_Y) );
   assert( m_chromaFormatIDC == pcPicYuvDst->getChromaFormat() );
 
-  for(Int chan=0; chan<getNumberValidComponents(); chan++)
-  {
-    const ComponentID ch=ComponentID(chan);
-    ::memcpy ( pcPicYuvDst->getBuf(ch), m_apiPicBuf[ch], sizeof (Pel) * getStride(ch) * getTotalHeight(ch));
-  }
-  return;
+  for(Int comp=0; comp<getNumberValidComponents(); comp++)
+  {
+    const ComponentID compId=ComponentID(comp);
+    const Int width     = getWidth(compId);
+    const Int height    = getHeight(compId);
+    const Int strideSrc = getStride(compId);
+    assert(pcPicYuvDst->getWidth(compId) == width);
+    assert(pcPicYuvDst->getHeight(compId) == height);
+    if (strideSrc==pcPicYuvDst->getStride(compId))
+  {
+      ::memcpy ( pcPicYuvDst->getBuf(compId), getBuf(compId), sizeof(Pel)*strideSrc*getTotalHeight(compId));
+    }
+    else
+    {
+      const Pel *pSrc       = getAddr(compId);
+            Pel *pDest      = pcPicYuvDst->getAddr(compId);
+      const UInt strideDest = pcPicYuvDst->getStride(compId);
+
+      for(Int y=0; y<height; y++, pSrc+=strideSrc, pDest+=strideDest)
+      {
+        ::memcpy(pDest, pSrc, width*sizeof(Pel));
+      }
+    }
+  }
 }
 
@@ -214,40 +249,40 @@
   }
 
-  for(Int chan=0; chan<getNumberValidComponents(); chan++)
-  {
-    const ComponentID ch=ComponentID(chan);
-    Pel *piTxt=getAddr(ch); // piTxt = point to (0,0) of image within bigger picture.
-    const Int iStride=getStride(ch);
-    const Int iWidth=getWidth(ch);
-    const Int iHeight=getHeight(ch);
-    const Int iMarginX=getMarginX(ch);
-    const Int iMarginY=getMarginY(ch);
+  for(Int comp=0; comp<getNumberValidComponents(); comp++)
+  {
+    const ComponentID compId=ComponentID(comp);
+    Pel *piTxt=getAddr(compId); // piTxt = point to (0,0) of image within bigger picture.
+    const Int stride=getStride(compId);
+    const Int width=getWidth(compId);
+    const Int height=getHeight(compId);
+    const Int marginX=getMarginX(compId);
+    const Int marginY=getMarginY(compId);
 
     Pel*  pi = piTxt;
     // do left and right margins
-    for (Int y = 0; y < iHeight; y++)
-    {
-      for (Int x = 0; x < iMarginX; x++ )
-      {
-        pi[ -iMarginX + x ] = pi[0];
-        pi[    iWidth + x ] = pi[iWidth-1];
-      }
-      pi += iStride;
+    for (Int y = 0; y < height; y++)
+    {
+      for (Int x = 0; x < marginX; x++ )
+      {
+        pi[ -marginX + x ] = pi[0];
+        pi[    width + x ] = pi[width-1];
+      }
+      pi += stride;
     }
 
     // pi is now the (0,height) (bottom left of image within bigger picture
-    pi -= (iStride + iMarginX);
+    pi -= (stride + marginX);
     // pi is now the (-marginX, height-1)
-    for (Int y = 0; y < iMarginY; y++ )
-    {
-      ::memcpy( pi + (y+1)*iStride, pi, sizeof(Pel)*(iWidth + (iMarginX<<1)) );
+    for (Int y = 0; y < marginY; y++ )
+    {
+      ::memcpy( pi + (y+1)*stride, pi, sizeof(Pel)*(width + (marginX<<1)) );
     }
 
     // pi is still (-marginX, height-1)
-    pi -= ((iHeight-1) * iStride);
+    pi -= ((height-1) * stride);
     // pi is now (-marginX, 0)
-    for (Int y = 0; y < iMarginY; y++ )
-    {
-      ::memcpy( pi - (y+1)*iStride, pi, sizeof(Pel)*(iWidth + (iMarginX<<1)) );
+    for (Int y = 0; y < marginY; y++ )
+    {
+      ::memcpy( pi - (y+1)*stride, pi, sizeof(Pel)*(width + (marginX<<1)) );
     }
   }
@@ -259,35 +294,52 @@
 
 // NOTE: This function is never called, but may be useful for developers.
-Void TComPicYuv::dump (const Char* pFileName, const BitDepths &bitDepths, Bool bAdd) const
-{
-  FILE* pFile;
-  if (!bAdd)
-  {
-    pFile = fopen (pFileName, "wb");
-  }
-  else
-  {
-    pFile = fopen (pFileName, "ab");
-  }
-
-
-  for(Int chan = 0; chan < getNumberValidComponents(); chan++)
-  {
-    const ComponentID  ch     = ComponentID(chan);
-    const Int          shift  = bitDepths.recon[toChannelType(ch)] - 8;
-    const Int          offset = (shift>0)?(1<<(shift-1)):0;
-    const Pel         *pi     = getAddr(ch);
-    const Int          stride = getStride(ch);
-    const Int          height = getHeight(ch);
-    const Int          width  = getWidth(ch);
-
+Void TComPicYuv::dump (const std::string &fileName, const BitDepths &bitDepths, const Bool bAppend, const Bool bForceTo8Bit) const
+{
+  FILE *pFile = fopen (fileName.c_str(), bAppend?"ab":"wb");
+
+  Bool is16bit=false;
+  for(Int comp = 0; comp < getNumberValidComponents() && !bForceTo8Bit; comp++)
+  {
+    if (bitDepths.recon[toChannelType(ComponentID(comp))]>8)
+  {
+      is16bit=true;
+    }
+  }
+
+  for(Int comp = 0; comp < getNumberValidComponents(); comp++)
+  {
+    const ComponentID  compId = ComponentID(comp);
+    const Pel         *pi     = getAddr(compId);
+    const Int          stride = getStride(compId);
+    const Int          height = getHeight(compId);
+    const Int          width  = getWidth(compId);
+
+    if (is16bit)
+    {
     for (Int y = 0; y < height; y++ )
     {
       for (Int x = 0; x < width; x++ )
       {
-        UChar uc = (UChar)Clip3<Pel>(0, 255, (pi[x]+offset)>>shift);
+          UChar uc = (UChar)((pi[x]>>0) & 0xff);
         fwrite( &uc, sizeof(UChar), 1, pFile );
+          uc = (UChar)((pi[x]>>8) & 0xff);
+          fwrite( &uc, sizeof(UChar), 1, pFile );
       }
       pi += stride;
+    }
+  }
+    else
+    {
+      const Int shift  = bitDepths.recon[toChannelType(compId)] - 8;
+      const Int offset = (shift>0)?(1<<(shift-1)):0;
+      for (Int y = 0; y < height; y++ )
+      {
+        for (Int x = 0; x < width; x++ )
+        {
+          UChar uc = (UChar)Clip3<Pel>(0, 255, (pi[x]+offset)>>shift);
+          fwrite( &uc, sizeof(UChar), 1, pFile );
+        }
+        pi += stride;
+      }
     }
   }
Index: trunk/source/Lib/TLibCommon/TComPicYuv.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComPicYuv.h	(revision 1357)
+++ trunk/source/Lib/TLibCommon/TComPicYuv.h	(revision 1386)
@@ -69,6 +69,6 @@
   // ------------------------------------------------------------------------------------------------
 
-  Int   m_iPicWidth;                                ///< Width of picture in pixels
-  Int   m_iPicHeight;                               ///< Height of picture in pixels
+  Int   m_picWidth;                                 ///< Width of picture in pixels
+  Int   m_picHeight;                                ///< Height of picture in pixels
   ChromaFormat m_chromaFormatIDC;                   ///< Chroma Format
 
@@ -76,6 +76,6 @@
   Int*  m_subCuOffsetInBuffer[MAX_NUM_CHANNEL_TYPE];///< Gives an offset in the buffer for a given sub-CU (and channel), relative to start of CTU
 
-  Int   m_iMarginX;                                 ///< margin of Luma channel (chroma's may be smaller, depending on ratio)
-  Int   m_iMarginY;                                 ///< margin of Luma channel (chroma's may be smaller, depending on ratio)
+  Int   m_marginX;                                  ///< margin of Luma channel (chroma's may be smaller, depending on ratio)
+  Int   m_marginY;                                  ///< margin of Luma channel (chroma's may be smaller, depending on ratio)
 
   Bool  m_bIsBorderExtended;
@@ -100,11 +100,18 @@
   // ------------------------------------------------------------------------------------------------
 
-  Void          create            (const Int iPicWidth,
-                                   const Int iPicHeight,
+  Void          create            (const Int picWidth,
+                                   const Int picHeight,
                                    const ChromaFormat chromaFormatIDC,
-                                   const UInt uiMaxCUWidth,  ///< used for generating offsets to CUs. Can use iPicWidth if no offsets are required
-                                   const UInt uiMaxCUHeight, ///< used for generating offsets to CUs. Can use iPicHeight if no offsets are required
-                                   const UInt uiMaxCUDepth,  ///< used for generating offsets to CUs. Can use 0 if no offsets are required
+                                   const UInt maxCUWidth,  ///< used for generating offsets to CUs.
+                                   const UInt maxCUHeight, ///< used for generating offsets to CUs.
+                                   const UInt maxCUDepth,  ///< used for generating offsets to CUs.
                                    const Bool bUseMargin);   ///< if true, then a margin of uiMaxCUWidth+16 and uiMaxCUHeight+16 is created around the image.
+
+  Void          createWithoutCUInfo(const Int picWidth,
+                                    const Int picHeight,
+                                    const ChromaFormat chromaFormatIDC,
+                                    const Bool bUseMargin=false, ///< if true, then a margin of uiMaxCUWidth+16 and uiMaxCUHeight+16 is created around the image.
+                                    const UInt maxCUWidth=0,   ///< used for margin only
+                                    const UInt maxCUHeight=0); ///< used for margin only
 
   Void          destroy           ();
@@ -118,14 +125,17 @@
   // ------------------------------------------------------------------------------------------------
 
-  Int           getWidth          (const ComponentID id) const { return  m_iPicWidth >> getComponentScaleX(id);   }
-  Int           getHeight         (const ComponentID id) const { return  m_iPicHeight >> getComponentScaleY(id);  }
+  Int           getWidth          (const ComponentID id) const { return  m_picWidth >> getComponentScaleX(id);   }
+  Int           getHeight         (const ComponentID id) const { return  m_picHeight >> getComponentScaleY(id);  }
   ChromaFormat  getChromaFormat   ()                     const { return m_chromaFormatIDC; }
   UInt          getNumberValidComponents() const { return ::getNumberValidComponents(m_chromaFormatIDC); }
 
-  Int           getStride         (const ComponentID id) const { return ((m_iPicWidth     ) + (m_iMarginX  <<1)) >> getComponentScaleX(id); }
-  Int           getTotalHeight    (const ComponentID id) const { return ((m_iPicHeight    ) + (m_iMarginY  <<1)) >> getComponentScaleY(id); }
-
-  Int           getMarginX        (const ComponentID id) const { return m_iMarginX >> getComponentScaleX(id);  }
-  Int           getMarginY        (const ComponentID id) const { return m_iMarginY >> getComponentScaleY(id);  }
+  Int           getStride         (const ComponentID id) const { return ((m_picWidth     ) + (m_marginX  <<1)) >> getComponentScaleX(id); }
+private:
+  Int           getStride         (const ChannelType id) const { return ((m_picWidth     ) + (m_marginX  <<1)) >> getChannelTypeScaleX(id); }
+public:
+  Int           getTotalHeight    (const ComponentID id) const { return ((m_picHeight    ) + (m_marginY  <<1)) >> getComponentScaleY(id); }
+
+  Int           getMarginX        (const ComponentID id) const { return m_marginX >> getComponentScaleX(id);  }
+  Int           getMarginY        (const ComponentID id) const { return m_marginY >> getComponentScaleY(id);  }
 
   // ------------------------------------------------------------------------------------------------
@@ -135,4 +145,5 @@
   //  Access starting position of picture buffer with margin
   Pel*          getBuf            (const ComponentID ch)       { return  m_apiPicBuf[ch];   }
+  const Pel*    getBuf            (const ComponentID ch) const { return  m_apiPicBuf[ch];   }
 
   //  Access starting position of original picture
@@ -151,4 +162,7 @@
   UInt          getComponentScaleY(const ComponentID id) const { return ::getComponentScaleY(id, m_chromaFormatIDC); }
 
+  UInt          getChannelTypeScaleX(const ChannelType id) const { return ::getChannelTypeScaleX(id, m_chromaFormatIDC); }
+  UInt          getChannelTypeScaleY(const ChannelType id) const { return ::getChannelTypeScaleY(id, m_chromaFormatIDC); }
+
   // ------------------------------------------------------------------------------------------------
   //  Miscellaneous
@@ -162,5 +176,5 @@
 
   //  Dump picture
-  Void          dump              (const Char* pFileName, const BitDepths &bitDepths, Bool bAdd = false) const ;
+  Void          dump              (const std::string &fileName, const BitDepths &bitDepths, const Bool bAppend=false, const Bool bForceTo8Bit=false) const ;
 
   // Set border extension flag
@@ -169,8 +183,10 @@
   Bool          getBorderExtension( )     { return m_bIsBorderExtended; }
 #endif
-#if NH_3D
+#if NH_3D_VSO
   // Set Function 
   Void  setLumaTo    ( Pel pVal );  
   Void  setChromaTo  ( Pel pVal );  
+#endif
+#if NH_3D
 #if NH_3D_IV_MERGE
   // sample to block and block to sample conversion
Index: trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 1357)
+++ trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 1386)
@@ -209,5 +209,5 @@
 std::string hashToString(const TComPictureHash &digest, Int numChar)
 {
-  static const Char* hex = "0123456789abcdef";
+  static const TChar* hex = "0123456789abcdef";
   std::string result;
 
